require 'nokogiri'
require 'open-uri'
require 'json'

class ExchangeRate
  attr_reader :date, :nok, :sek

  def initialize(currency_options)
    @date  = currency_options.first
    @nok   = currency_options.last["NOK"]
    @sek   = currency_options.last["SEK"]
  end

  def self.all
    file_path = File.dirname(__FILE__) + "/data/currency.json"
    file      = process_file(file_path)
  end

  def self.at(date, base, counter)
    counter_data = []
    @date = date_initialize(date)
    @base         = base
    @counter      = counter.downcase
    file_path = File.dirname(__FILE__) + "/data/currency.json"
    # response_from_file =  process_file('./data/currency.json')
    response_from_file =  process_file(file_path)

    response_from_file.each do |data|
      if data.date == @date
        counter_data << data
      end
    end

    unless counter_data.empty?
      date_r = counter_data.first.date
      nok  = counter_data.first.nok
      sek  = counter_data.first.sek
      case @counter
        when "sek"
           "1 euro = #{sek}"
        when "nok"
           "1 euro = #{nok}"
        else
           "Out of bound"
      end

    else
       "No data found"
    end

  end

  def self.date_initialize(date)
    @today_date = Date.today.strftime("%Y-%m-%d")
    @new_date = date.to_s
    if(@new_date == @today_date || @new_date > "2018-05-15")
      @new_date = "2018-05-15"
    else
      @new_date = date.to_s
    end
  end

  def self.process_file(file)
    response_data = []
    file          = File.read(file)
    hash_data     = JSON.parse(file)
    hash_data.map{|data| ExchangeRate.new(data)}
  end



end